' ClipOut.VBS V1.07 (C) yoshioka.teruo@nifty.com 2005-04-03
' ClipOut.VBS prints out text from clipboard to standard output.
' Usage: CScript.EXE //NoLogo ClipOut.VBS [>stdout]

Option Explicit

Const ForWriting=2
Const ForAppending = 8

Dim fso
Dim Text
Dim fname
Dim file
Dim Default

Set fso=CreateObject("Scripting.FileSystemObject")
Default=fso.BuildPath(fso.GetAbsolutePathName(""),"ClipSave.txt")
If WScript.Arguments.Count>0 Then
  fname=WScript.Arguments.Item(0)
  fname=fso.GetAbsolutePathName(fname)
End If

Text=GetCLipByMsForms()
If IsNull(Text) Then Text=GetCLipByMsIE()

If fname="" And _
  UCase(fso.GetBaseName(WScript.FullName))="CSCRIPT" Then
  WScript.StdOut.Write Text
Else
  If fname="" Then
    fname=FileSaveAs(Default)
    If IsNull(fname) Then fname=zFileSaveAs(Default)
    If IsNull(fname) Then fname=yFileSaveAs(Default)
    If IsNull(fname) Then fname=xFileSaveAs(Default)
  End If
  If fname<>"" Then
    Set file=fso.OpenTextFile(fname,ForAppending,True)
    file.Write(Text)
    file.Close
  Else
    WScript.Echo Text
'    WScript.Echo "File not specified. Canceled to save."
  End If
End If
WScript.Quit

Function GetCLipByMsIE()
Const OLECMDID_PASTE = 13
Const OLECMDEXECOPT_DODEFAULT = 0
Dim ie
Set ie=CreateObject("InternetExplorer.Application")
'ie.Visible=true
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.write "<html><body><textarea id=txt></textarea></body></html>"
ie.Document.all.txt.focus
Call ie.ExecWB(OLECMDID_PASTE,OLECMDEXECOPT_DODEFAULT)
GetCLipByMsIE=ie.Document.all.txt.value
ie.Quit 
End Function

Function GetCLipByMsForms()
Dim uf
Dim tb
Dim Text
On Error Resume Next
Set uf=CreateObject("Forms.Form.1")
On Error GoTo 0
If IsEmpty(uf) Then
  GetCLipByMsForms=Null
  Exit Function
End If
Set tb=uf.Controls.Add("Forms.TextBox.1").Object
tb.MultiLine=True
If tb.CanPaste Then
  tb.Paste
End If
Text=tb.Text
Set tb=Nothing
Set uf=Nothing
GetCLipByMsForms=Text
End Function

Function FileSaveAs(fname)
Const cdlOFNOverwritePrompt = 2
Const cdlCancel = 32755
Dim cdl
On Error Resume Next
Set cdl=CreateObject("MSComDlg.CommonDialog")
On Error GoTo 0
If IsEmpty(cdl) Then
  FileSaveAs=Null
  Exit Function
End If
cdl.CancelError = True
cdl.MaxFileSize = 512
cdl.filename = fso.GetFileName(fname)
cdl.InitDir = fso.GetParentFolderName(fname)
cdl.Filter = "eLXgt@C(*.txt)|*.txt|ׂẴt@C(*.*)|*.*"
cdl.Flags = cdlOFNOverwritePrompt
On Error Resume Next
cdl.ShowSave
If Err.Number = cdlCancel Then Exit Function
FileSaveAs = cdl.filename
End Function

Function xFileSaveAs(fname)
Dim xl
Dim filter
On Error Resume Next
Set xl=CreateObject("Excel.Application")
On Error GoTo 0
If IsEmpty(xl) Then
  xFileSaveAs=Null
  Exit Function
End If
filter="eLXgt@C(*.txt),*.txt,ׂẴt@C(*.*),*.*"
xFileSaveAs=xl.GetSaveAsFileName(fname,filter)
Set xl=Nothing
If xFileSaveAs=False Then xFileSaveAs=""
End Function

Function yFileSaveAs(fname)
Dim cdl
On Error Resume Next
Set cdl=CreateObject("SAFRCFileDlg.FileSave") 
On Error GoTo 0
If IsEmpty(cdl) Then
  yFileSaveAs=Null
  Exit Function
End If
cdl.FileName=fname
cdl.FileType="ׂẴt@C(*.*)" 
If cdl.OpenFileSaveDlg() Then yFileSaveAs=cdl.FileName 
End Function

Function zFileSaveAs(fname)
Dim cdl
On Error Resume Next
Set cdl=CreateObject("UserAccounts.CommonDialog") 
On Error GoTo 0
If IsEmpty(cdl) Then
  zFileSaveAs=Null
  Exit Function
End If
cdl.FileName=fname
'cdl.InitialDir="C:\vbs" 
cdl.Filter="eLXgt@C(*.txt)|*.txt|ׂẴt@C(*.*)|*.*" 
cdl.FilterIndex=1 
cdl.Flags=0 
If cdl.ShowOpen() Then zFileSaveAs=cdl.FileName 
End Function
